# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin
import sys, json
try:
    from urllib2 import urlopen
except ImportError:
    from urllib.request import urlopen
try:
    from urllib import urlencode
except ImportError:
    from urllib.parse import urlencode
try:
    from urlparse import urlparse, parse_qs
except ImportError:
    from urllib.parse import urlparse, parse_qs
import youku


def play(title, url):
    listitem = xbmcgui.ListItem(title)
    xbmc.Player().play(url, listitem)


def resp(ret, recur=False):
    if 'code' in ret:
        if 'error' in ret:
            return xbmcgui.Dialog().ok('Error: ' + ret['code'], ret['error'])
        return xbmcgui.Dialog().ok('Error', ret['code'])
    if isinstance(ret, list):
        xbmcplugin.setContent(handle, 'videos')
        for elem in ret:
            resp(elem, True)
        return xbmcplugin.endOfDirectory(handle)
    assert isinstance(ret, dict)
    if 'title' not in ret:
        for k, v in ret.items():
            if isinstance(v, list):
                ret = {'title': k, 'json': json.dumps(v)}
            else:
                ret = {'title': k, 'url': v}
    li = xbmcgui.ListItem(ret['title'])
    if 'img' in ret:
        li.setArt({'thumb': ret['img']})
    if 'plot' in ret:
        li.setInfo('video', {'plot': ret['plot']})
    t = True
    if 'url' in ret:
        if isinstance(ret['url'], list):
            ret['url'] = 'stack://' + ' , '.join(ret['url'])
            if 'header' in ret:
                ret['url'] += '|' + urlencode(ret['header'])
            if recur:
                return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
            else:
                return xbmc.Player().play(ret['url'], li)
        o = urlparse(ret['url'])
        p = o.path.split('/')
        ext = p[-1].split('.')[-1]
        if ext in ('m3u', 'm3u8'):
            if 'header' in ret:
                ret['url'] += '|' + urlencode(ret['header'])
            if recur:
                return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
            else:
                return xbmc.Player().play(ret['url'], li)
        if t:
            t = sub1(ret['url'])
    for k, v in ret.items():
        try:
            ret[k] = v.encode('utf-8')
        except:
            pass
    xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(ret), li, t)


def sub1(url):
    return True


def sub2(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    if o.netloc == 'v.youku.com':
        if p[1] == 'v_show' and p[2].startswith('id_'):
            return resp(youku.play(url))
            # return resp(youku.ykdl(url))
    if o.netloc == 'www.youku.com':
        if p[1] == 'show_page':
            return resp(youku.show_page(url))
        if p[1] == 'show_episode':
            return resp(youku.show_episode(url))
        if p[1] == 'playlist_show':
            return resp(youku.playlist_show(url))
    if o.netloc == 'list.youku.com':
        if p[1] == 'show' and p[2].startswith('id_'):
            return resp(youku.list_show_id(url))
        if p[1] == 'show' and p[2] == 'point':
            return resp(youku.list_show_point(url))
    return resp({'code': 'youku 020', 'error': url})


def sub3(content):
    try:
        data = json.loads(content)
    except Exception as e:
        return resp({'code': 'youku 030', 'error': str(e)})
    resp(data)


def get_node(url):
    try:
        content = urlopen(url).read().decode('utf-8')
    except Exception as e:
        return resp({'code': 'youku 010', 'error': str(e)})
    sub3(content)


handle = int(sys.argv[1])
url = sys.argv[2]
if not url:
    get_node('http://ims.tian-le.com/youku.json')
else:
    o = urlparse(url)
    q = parse_qs(o.query, True)
    if 'json' in q:
        sub3(q['json'][0])
    elif 'url' in q:
        sub2(q['url'][0])
